#define CPU_FREQ ((__int64)3000000ULL) /* 3GHz CPU */

#define Uint32 unsigned long int
#define __int64 unsigned long long

inline __int64 RDTSC()
{
 unsigned int lo,hi;
 asm volatile ("rdtsc\n" : "=a" (lo),"=d" (hi));
 return ((__int64)hi<<32)|lo;
}

Uint32 SDL_GetTicks(void) // 
{
 return (Uint32)(RDTSC()/CPU_FREQ);
}

void SDL_Delay(Uint32 ms) //  
{
 __int64 t0=RDTSC();
 while(RDTSC()-t0<((__int64)ms*CPU_FREQ));
}
