unsigned short int VideoRAM;

#define VIDEO_BANK 1
#define MINI_OFFSET 104

void Video_Init(void)
{
 union REGS r;

 r.x.ax=0x4F02;
 r.x.bx=0x112;                                  //Mode 0x112 => 640x480 24 bpp
 int86(0x10,&r,&r);

 r.x.ax=0x4F05;                                 //VideoBank Set
 r.x.bx=0;
 r.x.dx=VIDEO_BANK;
 int86(0x10,&r,&r);

 outp(0x3D4,0x11);                              //Protection
 outp(0x3D5,inp(0x3D5)&0x7F);                   //UnLock
 outpw(0x3D4,0x13|((W>>3)<<8));                 //Logical HLine
 outpw(0x3D4,0x01|(((W>>3)-1)<<8));             //Visible HLine

 VideoRAM=__dpmi_segment_to_descriptor(0xA000+MINI_OFFSET);
}

void Video_DeInit(void)
{
 union REGS r;
 r.x.ax=0x0003;
 int86(0x10,&r,&r);
}
