ifeq ($(OSTYPE),Win32)
CC        = g++
else
CC        = gpp
endif

STRIP     = strip

OBJS      = huffman.o rle.o decoder.o
BIN       ?= decoder.exe

VPATH      += ..
CFLAGS     += -O3 -D$(OSTYPE) -DNDEBUG
LIBS       = -L${PREFIX}/lib

ifeq ($(OSTYPE),Win32)
LIBS       += -static-libgcc -static-libstdc++
endif

.SUFFIXES: .c

%.o: %.c
	${CC} ${CFLAGS} ${INCLUDES} -c -o $@ $<

all:	${OBJS}
	${CC} ${OBJS} ${LIBS} -o ${BIN}  
	${STRIP} ${BIN}

clean:
	rm -f *.o ${BIN} 
